package org.bitbucket.bradleysmithllc.etlunit;

import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestClass;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestMethod;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

public class SuiteAggregator implements StatusReporter
{
	private final List<String> suiteList = new ArrayList<String>();

	@Override
	public void scanStarted()
	{
		suiteList.clear();
	}

	@Override
	public void scanCompleted()
	{
		Collections.sort(suiteList);
	}

	@Override
	public void testsStarted(int numTestsSelected)
	{
	}

	@Override
	public void testClassAccepted(ETLTestClass method)
	{
		List<String> memList = method.getSuiteMemberships();
		Iterator<String> it = memList.iterator();

		while (it.hasNext())
		{
			String suite = it.next();

			if (!suiteList.contains(suite))
			{
				suiteList.add(suite);
			}
		}
	}

	public List<String> getSuiteList()
	{
		return Collections.unmodifiableList(suiteList);
	}

	@Override
	public void testMethodAccepted(ETLTestMethod method)
	{
	}

	@Override
	public void testBeginning(ETLTestMethod method)
	{
	}

	@Override
	public void testCompleted(ETLTestMethod method, CompletionStatus status)
	{
	}

	@Override
	public void testsCompleted()
	{
	}
}