package org.bitbucket.bradleysmithllc.etlunit;

import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestClass;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestMethod;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestValueObject;
import org.bitbucket.bradleysmithllc.etlunit.util.CommandLine;

import java.io.IOException;
import java.util.Map;

public interface TestContext extends CommandLineSwitches
{
	Map<String, Object> getTestAttributeMap();

	Object getTestAttribute(String name);

	void setTestAttribute(String name, Object val);

	Map<String, Object> getClassAttributeMap();

	Object getClassAttribute(String name);

	void setClassAttribute(String name, Object val);

	Map<String, Object> getSystemAttributeMap();

	Object getSystemAttribute(String name);

	void setSystemAttribute(String name, Object val);

	CommandLine getCommandLine();

	void executeOperation(String operationName, ETLTestValueObject operands) throws Exception;

	void executeOperation(String operationName, String operands) throws Exception;

	ETLTestValueObject parseOperands(String map);

	void writeToProcessLog(byte[] bytes, int offset, int length) throws IOException;

	void writeToProcessLog(String msg) throws IOException;

	void writeToProcessLog(String[] msgs) throws IOException;

	void testClassRunning(ETLTestClass itc);

	void testMethodRunning(ETLTestMethod itm) throws TestExecutionError;

	void testMethodCompleted();

	void testFailed();

	void testErrored();

	void dispose();

	boolean checkRuntimeOption(CommandLine.Switch name);

	boolean checkRuntimeOption(CommandLine.Switch name, boolean optionDefault, boolean flagDefault);

	String getRuntimeOption(CommandLine.Switch name);
}