package org.bitbucket.bradleysmithllc.etlunit.feature;

import com.fasterxml.jackson.databind.JsonNode;
import com.github.fge.jsonschema.main.JsonSchema;

import java.util.List;
import java.util.Map;

public interface FeatureMetaInfo
{
	String getFeatureName();

	String getFeatureConfiguration();

	JsonSchema getFeatureConfigurationValidator();
	JsonNode getFeatureConfigurationValidatorNode();

	Map<String, FeatureOperation> getExportedOperations();

	Map<String, FeatureAnnotation> getExportedAnnotations();

	boolean isInternalFeature();

	String getFeatureUsage();

	List<RuntimeOptionDescriptor> getOptions();

	String getDescribingClassName();

	Feature getDescribing();
}